
// Waveshapers

void setSwitch()
{
  effectSelect = 1 + (effectCVIN >> 9); // top 3 bits = selected effect
  signalTemp = signalInternal;
  stages();
  signalInternal = signalTemp;
}


void setMorph()
{
  targetFX = effectCVIN >> 9; // top 3 bits = selected effect
  morphTo = effectCVIN & 511; // bottom 9 bits are amount of blend
  morphFrom = 511 - morphTo;
  signalTemp = signalInternal; // get currently active FX
  effectSelect = targetFX;
  stages();
  morphSigF = signalTemp;
  signalTemp = signalInternal; // get next FX that blending to
  effectSelect = targetFX + 1;
  stages();
  morphSigT = signalTemp;

  signalLong = (morphSigF * morphFrom) + (morphSigT * morphTo);
  signalInternal = signalLong >> 9;
}


void stages()
{
  switch (effectSelect) {

    case 1:// sine
      b = 4096 - signalTemp;
      signalTemp = sineTable[b];
      break;

    case 2: // fold
      signalTemp = 4095 - sineTableB[signalTemp];
      break;

    case 3: // rectify with fold
      signalTemp = sineTableB[signalTemp];
      if (signalTemp > 2048)
      {
        signalTemp ^= 4095;
      }
      signalTemp = signalTemp << 1;
      break;

    case 4:  // rectify
      if (signalTemp > 2048)
      {
        signalTemp ^= 4095;
      }
      signalTemp = signalTemp << 1;
      break;

    case 5: // rotate left  with fold
      signalTemp = sineTableB[signalTemp];
      signalTemp &= 2047;
      signalTemp = signalTemp << 1;
      break;

    case 6: // "rotate left"
      signalTemp &= 2047;
      signalTemp = signalTemp << 1;
      break;

    case 7: // XOR
      signalTemp ^= 2730;
      break;

    case 8: // Swap
      b = (signalTemp & 63) << 6;
      signalTemp = (signalTemp & 4032) >> 6;
      signalTemp = signalTemp + b;
      break;
  }
}


